Index: /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/AdaptiveRandomTopologyUpdater.cs
===================================================================
--- /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/AdaptiveRandomTopologyUpdater.cs	(revision 15277)
+++ /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/AdaptiveRandomTopologyUpdater.cs	(revision 15277)
@@ -0,0 +1,96 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ParticleSwarmOptimization {
+  [Item("SPSO Adaptive Random Topology Updater", "Each unsuccessful iteration the topology initializer is applied again.")]
+  [StorableClass]
+  public sealed class SPSOAdaptiveRandomTopologyUpdater : SingleSuccessorOperator, ITopologyUpdater, ISingleObjectiveOperator {
+
+    public override bool CanChangeName {
+      get { return false; }
+    }
+
+    #region Parameters
+    public ILookupParameter<BoolValue> MaximizationParameter {
+      get { return (ILookupParameter<BoolValue>)Parameters["Maximization"]; }
+    }
+    public ILookupParameter<DoubleValue> SwarmBestQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["SwarmBestQuality"]; }
+    }
+    public ILookupParameter<DoubleValue> PreviousBestQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["PreviousBestQuality"]; }
+    }
+    public ILookupParameter<ITopologyInitializer> TopologyInitializerParameter {
+      get { return (ILookupParameter<ITopologyInitializer>)Parameters["TopologyInitializer"]; }
+    }
+    public IScopeTreeLookupParameter<IntArray> NeighborsParameter {
+      get { return (IScopeTreeLookupParameter<IntArray>)Parameters["Neighbors"]; }
+    }
+    #endregion
+
+    #region Construction & Cloning
+    [StorableConstructor]
+    private SPSOAdaptiveRandomTopologyUpdater(bool deserializing) : base(deserializing) { }
+    private SPSOAdaptiveRandomTopologyUpdater(SPSOAdaptiveRandomTopologyUpdater original, Cloner cloner) : base(original, cloner) { }
+    public SPSOAdaptiveRandomTopologyUpdater()
+      : base() {
+      Parameters.Add(new LookupParameter<BoolValue>("Maximization", "Whether the problem is to be maximized or not."));
+      Parameters.Add(new LookupParameter<DoubleValue>("SwarmBestQuality", "The swarm's best quality."));
+      Parameters.Add(new LookupParameter<DoubleValue>("PreviousBestQuality", "The best quality of the previous iteration."));
+      Parameters.Add(new LookupParameter<ITopologyInitializer>("TopologyInitializer", "The topology initializer is called again in case no improvement is made."));
+      Parameters.Add(new ScopeTreeLookupParameter<IntArray>("Neighbors", "The list of neighbors for each particle."));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SPSOAdaptiveRandomTopologyUpdater(this, cloner);
+    }
+    #endregion
+
+    public override IOperation Apply() {
+      var swarmBest = SwarmBestQualityParameter.ActualValue;
+      if (swarmBest == null) return base.Apply();
+
+      var previousBest = PreviousBestQualityParameter.ActualValue;
+      if (previousBest == null) {
+        PreviousBestQualityParameter.ActualValue = new DoubleValue(swarmBest.Value);
+        return base.Apply();
+      };
+
+      var successor = new OperationCollection(new[] { base.Apply() });
+      var max = MaximizationParameter.ActualValue.Value;
+      if (max && swarmBest.Value <= previousBest.Value
+        || !max && swarmBest.Value >= previousBest.Value)
+        successor.Insert(0, ExecutionContext.CreateOperation(TopologyInitializerParameter.ActualValue));
+
+      previousBest.Value = swarmBest.Value;
+      return successor;
+    }
+  }
+}
Index: /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/HeuristicLab.Algorithms.ParticleSwarmOptimization-3.3.csproj
===================================================================
--- /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/HeuristicLab.Algorithms.ParticleSwarmOptimization-3.3.csproj	(revision 15276)
+++ /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/HeuristicLab.Algorithms.ParticleSwarmOptimization-3.3.csproj	(revision 15277)
@@ -113,7 +113,9 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="AdaptiveRandomTopologyUpdater.cs" />
     <Compile Include="MultiPSOTopologyUpdater.cs" />
     <Compile Include="ParticleSwarmOptimizationMainLoop.cs" />
     <Compile Include="Plugin.cs" />
+    <Compile Include="SPSORandomTopologyInitializer.cs" />
     <Compile Include="RandomTopologyInitializer.cs" />
     <Compile Include="VonNeumannTopologyInitializer.cs" />
Index: /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/MultiPSOTopologyUpdater.cs
===================================================================
--- /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/MultiPSOTopologyUpdater.cs	(revision 15276)
+++ /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/MultiPSOTopologyUpdater.cs	(revision 15277)
@@ -33,5 +33,5 @@
   [Item("Multi PSO Topology Updater", "Splits swarm into NrOfSwarms non-overlapping sub-swarms. Swarms are re-grouped every regroupingPeriod iteration. The operator is implemented as described in Liang, J.J. and Suganthan, P.N 2005. Dynamic multi-swarm particle swarm optimizer. IEEE Swarm Intelligence Symposium, pp. 124-129.")]
   [StorableClass]
-  public sealed class MultiPSOTopologyUpdater : SingleSuccessorOperator, ITopologyUpdater {
+  public sealed class MultiPSOTopologyUpdater : SingleSuccessorOperator, ITopologyUpdater, IStochasticOperator {
 
     public override bool CanChangeName {
Index: /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/ParticleSwarmOptimization.cs
===================================================================
--- /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/ParticleSwarmOptimization.cs	(revision 15276)
+++ /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/ParticleSwarmOptimization.cs	(revision 15277)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Collections.Generic;
 using System.Linq;
 using HeuristicLab.Analysis;
@@ -35,5 +36,5 @@
 
 namespace HeuristicLab.Algorithms.ParticleSwarmOptimization {
-  [Item("Particle Swarm Optimization (PSO)", "A particle swarm optimization algorithm based on the description in Pedersen, M.E.H. (2010). PhD thesis. University of Southampton.")]
+  [Item("Particle Swarm Optimization (PSO)", "A particle swarm optimization algorithm based on Standard PSO (SPSO) as described in Clerc, M. (2012). Standard particle swarm optimisation.")]
   [Creatable(CreatableAttribute.Categories.PopulationBasedAlgorithms, Priority = 300)]
   [StorableClass]
@@ -176,10 +177,10 @@
       Parameters.Add(new ValueParameter<IntValue>("Seed", "The random seed used to initialize the new pseudo random number generator.", new IntValue(0)));
       Parameters.Add(new ValueParameter<BoolValue>("SetSeedRandomly", "True if the random seed should be set to a random value, otherwise false.", new BoolValue(true)));
-      Parameters.Add(new ValueParameter<IntValue>("SwarmSize", "Size of the particle swarm.", new IntValue(10)));
+      Parameters.Add(new ValueParameter<IntValue>("SwarmSize", "Size of the particle swarm.", new IntValue(40)));
       Parameters.Add(new ValueParameter<IntValue>("MaxIterations", "Maximal number of iterations.", new IntValue(1000)));
       Parameters.Add(new ValueParameter<MultiAnalyzer>("Analyzer", "The operator used to analyze each generation.", new MultiAnalyzer()));
-      Parameters.Add(new ValueParameter<DoubleValue>("Inertia", "Inertia weight on a particle's movement (omega).", new DoubleValue(1)));
-      Parameters.Add(new ValueParameter<DoubleValue>("PersonalBestAttraction", "Weight for particle's pull towards its personal best soution (phi_p).", new DoubleValue(-0.01)));
-      Parameters.Add(new ValueParameter<DoubleValue>("NeighborBestAttraction", "Weight for pull towards the neighborhood best solution or global best solution in case of a totally connected topology (phi_g).", new DoubleValue(3.7)));
+      Parameters.Add(new ValueParameter<DoubleValue>("Inertia", "Inertia weight on a particle's movement (omega).", new DoubleValue(0.721)));
+      Parameters.Add(new ValueParameter<DoubleValue>("PersonalBestAttraction", "Weight for particle's pull towards its personal best soution (phi_p).", new DoubleValue(1.193)));
+      Parameters.Add(new ValueParameter<DoubleValue>("NeighborBestAttraction", "Weight for pull towards the neighborhood best solution or global best solution in case of a totally connected topology (phi_g).", new DoubleValue(1.193)));
       Parameters.Add(new ConstrainedValueParameter<IParticleCreator>("ParticleCreator", "Operator that creates a new particle."));
       Parameters.Add(new ConstrainedValueParameter<IParticleUpdater>("ParticleUpdater", "Operator that updates a particle."));
@@ -188,5 +189,4 @@
       Parameters.Add(new OptionalConstrainedValueParameter<IDiscreteDoubleValueModifier>("InertiaUpdater", "Updates the omega parameter."));
       Parameters.Add(new ConstrainedValueParameter<ISwarmUpdater>("SwarmUpdater", "Encoding-specific parameter which is provided by the problem. May provide additional encoding-specific parameters, such as velocity bounds for real valued problems"));
-      ParticleUpdaterParameter.Hidden = true;
 
       RandomCreator randomCreator = new RandomCreator();
@@ -262,4 +262,5 @@
       UpdateAnalyzers();
       ParameterizeAnalyzers();
+      UpdateParticleUpdaterParameter();
       UpdateTopologyParameters();
       InitializeParticleCreator();
@@ -280,13 +281,13 @@
 
     private void InitializeParticleCreator() {
+      ParticleCreatorParameter.ValidValues.Clear();
       if (Problem != null) {
         IParticleCreator oldParticleCreator = ParticleCreator;
         IParticleCreator defaultParticleCreator = Problem.Operators.OfType<IParticleCreator>().FirstOrDefault();
-        ParticleCreatorParameter.ValidValues.Clear();
-        foreach (IParticleCreator Creator in Problem.Operators.OfType<IParticleCreator>().OrderBy(x => x.Name)) {
-          ParticleCreatorParameter.ValidValues.Add(Creator);
+        foreach (var creator in Problem.Operators.OfType<IParticleCreator>().OrderBy(x => x.Name)) {
+          ParticleCreatorParameter.ValidValues.Add(creator);
         }
         if (oldParticleCreator != null) {
-          IParticleCreator creator = ParticleCreatorParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldParticleCreator.GetType());
+          var creator = ParticleCreatorParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldParticleCreator.GetType());
           if (creator != null) ParticleCreator = creator;
           else oldParticleCreator = null;
@@ -328,6 +329,6 @@
         updater.IndexParameter.ActualName = "Iterations";
         updater.ValueParameter.ActualName = "CurrentInertia";
-        updater.StartValueParameter.Value = new DoubleValue(1);
-        updater.EndValueParameter.Value = new DoubleValue(1E-10);
+        updater.StartValueParameter.ActualName = InertiaParameter.Name;
+        updater.EndValueParameter.Value = new DoubleValue(0.70);
       }
     }
@@ -346,9 +347,10 @@
 
     private void UpdateTopologyInitializer() {
-      ITopologyInitializer oldTopologyInitializer = TopologyInitializer;
+      var oldTopologyInitializer = TopologyInitializer;
       TopologyInitializerParameter.ValidValues.Clear();
       foreach (ITopologyInitializer topologyInitializer in ApplicationManager.Manager.GetInstances<ITopologyInitializer>().OrderBy(x => x.Name)) {
         TopologyInitializerParameter.ValidValues.Add(topologyInitializer);
       }
+
       if (oldTopologyInitializer != null && TopologyInitializerParameter.ValidValues.Any(x => x.GetType() == oldTopologyInitializer.GetType()))
         TopologyInitializer = TopologyInitializerParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldTopologyInitializer.GetType());
@@ -357,35 +359,20 @@
 
     private void ParameterizeTopologyUpdaters() {
-      foreach (var updater in TopologyUpdaterParameter.ValidValues) {
-        var multiPsoUpdater = updater as MultiPSOTopologyUpdater;
-        if (multiPsoUpdater != null) {
-          multiPsoUpdater.CurrentIterationParameter.ActualName = "Iterations";
-        }
-      }
-    }
-
-    private void UpdateTopologyParameters() {
-      ITopologyUpdater oldTopologyUpdater = TopologyUpdater;
-      IParticleUpdater oldParticleUpdater = ParticleUpdater;
-      ClearTopologyParameters();
-      if (Problem != null) {
-        IParticleUpdater defaultParticleUpdater = null;
-        if (TopologyInitializer != null) {
-          foreach (ITopologyUpdater topologyUpdater in ApplicationManager.Manager.GetInstances<ITopologyUpdater>())
-            TopologyUpdaterParameter.ValidValues.Add(topologyUpdater);
-          defaultParticleUpdater = Problem.Operators.OfType<ILocalParticleUpdater>().FirstOrDefault();
-          foreach (IParticleUpdater particleUpdater in Problem.Operators.OfType<ILocalParticleUpdater>().OrderBy(x => x.Name))
-            ParticleUpdaterParameter.ValidValues.Add(particleUpdater);
-        } else {
-          defaultParticleUpdater = Problem.Operators.OfType<IGlobalParticleUpdater>().FirstOrDefault();
-          foreach (IParticleUpdater particleUpdater in Problem.Operators.OfType<IGlobalParticleUpdater>().OrderBy(x => x.Name))
-            ParticleUpdaterParameter.ValidValues.Add(particleUpdater);
-        }
-        if (oldTopologyUpdater != null) {
-          ITopologyUpdater newTopologyUpdater = TopologyUpdaterParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldParticleUpdater.GetType());
-          if (newTopologyUpdater != null) TopologyUpdater = newTopologyUpdater;
-        }
+      foreach (var updater in TopologyUpdaterParameter.ValidValues.OfType<MultiPSOTopologyUpdater>()) {
+        updater.CurrentIterationParameter.ActualName = "Iterations";
+      }
+    }
+
+    private void UpdateParticleUpdaterParameter() {
+      var oldParticleUpdater = ParticleUpdater;
+      ParticleUpdaterParameter.ValidValues.Clear();
+      if (Problem != null) {
+        var defaultParticleUpdater = Problem.Operators.OfType<IParticleUpdater>().FirstOrDefault();
+
+        foreach (var particleUpdater in Problem.Operators.OfType<IParticleUpdater>().OrderBy(x => x.Name))
+          ParticleUpdaterParameter.ValidValues.Add(particleUpdater);
+
         if (oldParticleUpdater != null) {
-          IParticleUpdater newParticleUpdater = ParticleUpdaterParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldParticleUpdater.GetType());
+          var newParticleUpdater = ParticleUpdaterParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldParticleUpdater.GetType());
           if (newParticleUpdater != null) ParticleUpdater = newParticleUpdater;
           else oldParticleUpdater = null;
@@ -393,12 +380,22 @@
         if (oldParticleUpdater == null && defaultParticleUpdater != null)
           ParticleUpdater = defaultParticleUpdater;
-
-        ParameterizeTopologyUpdaters();
-      }
-    }
-
-    private void ClearTopologyParameters() {
+      }
+    }
+
+    private void UpdateTopologyParameters() {
+      ITopologyUpdater oldTopologyUpdater = TopologyUpdater;
       TopologyUpdaterParameter.ValidValues.Clear();
-      ParticleUpdaterParameter.ValidValues.Clear();
+      if (Problem != null) {
+        if (TopologyInitializerParameter.Value != null) {
+          foreach (ITopologyUpdater topologyUpdater in ApplicationManager.Manager.GetInstances<ITopologyUpdater>())
+            TopologyUpdaterParameter.ValidValues.Add(topologyUpdater);
+
+          if (oldTopologyUpdater != null) {
+            ITopologyUpdater newTopologyUpdater = TopologyUpdaterParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldTopologyUpdater.GetType());
+            if (newTopologyUpdater != null) TopologyUpdater = newTopologyUpdater;
+          }
+          ParameterizeTopologyUpdaters();
+        }
+      }
     }
 
Index: /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/ParticleSwarmOptimizationMainLoop.cs
===================================================================
--- /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/ParticleSwarmOptimizationMainLoop.cs	(revision 15276)
+++ /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/ParticleSwarmOptimizationMainLoop.cs	(revision 15277)
@@ -122,4 +122,5 @@
       Placeholder evaluatorPlaceholder = new Placeholder();
       Placeholder analyzerPlaceholder = new Placeholder();
+      Placeholder analyzer2Placeholder = new Placeholder();
       UniformSubScopesProcessor uniformSubScopeProcessor = new UniformSubScopesProcessor();
       Placeholder particleUpdaterPlaceholder = new Placeholder();
@@ -192,4 +193,8 @@
       conditionalBranch.ConditionParameter.ActualName = "ContinueIteration";
       conditionalBranch.TrueBranch = analyzerPlaceholder;
+      conditionalBranch.FalseBranch = analyzer2Placeholder;
+
+      analyzer2Placeholder.Name = "(Analyzer)";
+      analyzer2Placeholder.OperatorParameter.ActualName = AnalyzerParameter.Name;
       #endregion
     }
Index: /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/RandomTopologyInitializer.cs
===================================================================
--- /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/RandomTopologyInitializer.cs	(revision 15276)
+++ /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/RandomTopologyInitializer.cs	(revision 15277)
@@ -25,11 +25,12 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Algorithms.ParticleSwarmOptimization {
-  [Item("Random Topology Initializer", "Randomly connectes every particle with k other particles.")]
+  [Item("Random Distinct Topology Initializer", "Each particle is informed by exactly k+1 distinct other particles (including itself).")]
   [StorableClass]
-  public sealed class RandomTopologyInitializer : TopologyInitializer {
+  public sealed class RandomTopologyInitializer : TopologyInitializer, IStochasticOperator {
     #region Parameters
     public ILookupParameter<IRandom> RandomParameter {
@@ -40,14 +41,5 @@
     }
     #endregion
-
-    #region Parameter Values
-    private IRandom Random {
-      get { return RandomParameter.ActualValue; }
-    }
-    private int NrOfConnections {
-      get { return NrOfConnectionsParameter.ActualValue.Value; }
-    }
-    #endregion
-
+    
     #region Construction & Cloning
     [StorableConstructor]
@@ -65,11 +57,16 @@
 
     public override IOperation Apply() {
-      ItemArray<IntArray> neighbors = new ItemArray<IntArray>(SwarmSize);
-      for (int i = 0; i < SwarmSize; i++) {
-        var numbers = Enumerable.Range(0, SwarmSize).ToList();
+      var random = RandomParameter.ActualValue;
+      var swarmSize = SwarmSizeParameter.ActualValue.Value;
+      var nrOfConnections = NrOfConnectionsParameter.ActualValue.Value;
+
+      ItemArray<IntArray> neighbors = new ItemArray<IntArray>(swarmSize);
+      for (int i = 0; i < swarmSize; i++) {
+        var numbers = Enumerable.Range(0, swarmSize).ToList();
         numbers.RemoveAt(i);
-        var selectedNumbers = new List<int>(NrOfConnections);
-        for (int j = 0; j < NrOfConnections && numbers.Count > 0; j++) {
-          int index = Random.Next(numbers.Count);
+        var selectedNumbers = new List<int>(nrOfConnections + 1);
+        selectedNumbers.Add(i);
+        for (int j = 0; j < nrOfConnections && numbers.Count > 0; j++) {
+          int index = random.Next(numbers.Count);
           selectedNumbers.Add(numbers[index]);
           numbers.RemoveAt(index);
@@ -77,5 +74,5 @@
         neighbors[i] = new IntArray(selectedNumbers.ToArray());
       }
-      Neighbors = neighbors;
+      NeighborsParameter.ActualValue = neighbors;
       return base.Apply();
     }
Index: /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/RingTopologyInitializer.cs
===================================================================
--- /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/RingTopologyInitializer.cs	(revision 15276)
+++ /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/RingTopologyInitializer.cs	(revision 15277)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.Algorithms.ParticleSwarmOptimization {
-  [Item("Ring Topology Initializer", "Connected every particle with its preceeding and its following particle.")]
+  [Item("Ring Topology Initializer", "Each particle is informed by its preceeding and its succeeding particle wrapping around at the beginning and the end of the swarm (in addition each particle also informs itself).")]
   [StorableClass]
   public sealed class RingTopologyInitializer : TopologyInitializer {
@@ -43,9 +43,11 @@
 
     public override IOperation Apply() {
-      ItemArray<IntArray> neighbors = new ItemArray<IntArray>(SwarmSize);
-      for (int i = 0; i < SwarmSize; i++) {
-        neighbors[i] = new IntArray(new[] { (SwarmSize + i - 1) % SwarmSize, (i + 1) % SwarmSize });
+      var swarmSize = SwarmSizeParameter.ActualValue.Value;
+
+      ItemArray<IntArray> neighbors = new ItemArray<IntArray>(swarmSize);
+      for (int i = 0; i < swarmSize; i++) {
+        neighbors[i] = new IntArray(new[] { (swarmSize + i - 1) % swarmSize, i, (i + 1) % swarmSize });
       }
-      Neighbors = neighbors;
+      NeighborsParameter.ActualValue = neighbors;
       return base.Apply();
     }
Index: /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/SPSORandomTopologyInitializer.cs
===================================================================
--- /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/SPSORandomTopologyInitializer.cs	(revision 15277)
+++ /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/SPSORandomTopologyInitializer.cs	(revision 15277)
@@ -0,0 +1,84 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ParticleSwarmOptimization {
+  [Item("SPSO Random Topology Initializer", "Each particle informs k+1 other particles (including itself). The same particle (including itself) can be informed multiple times.")]
+  [StorableClass]
+  public sealed class SPSORandomTopologyInitializer : TopologyInitializer, IStochasticOperator {
+    #region Parameters
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public IValueLookupParameter<IntValue> KParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["K"]; }
+    }
+    #endregion
+    
+    #region Construction & Cloning
+    [StorableConstructor]
+    private SPSORandomTopologyInitializer(bool deserializing) : base(deserializing) { }
+    private SPSORandomTopologyInitializer(SPSORandomTopologyInitializer original, Cloner cloner) : base(original, cloner) { }
+    public SPSORandomTopologyInitializer() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "A random number generation."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("K", "The number of informed particles (excluding itself).", new IntValue(3)));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SPSORandomTopologyInitializer(this, cloner);
+    }
+    #endregion
+
+    public override IOperation Apply() {
+      var random = RandomParameter.ActualValue;
+      var swarmSize = SwarmSizeParameter.ActualValue.Value;
+      var k = KParameter.ActualValue.Value;
+
+      // SPSO: Each particle informs at most K+1 particles (at least itself and K others)
+      //       it is by design that we draw from the particles with repetition
+      var particlesInform = new List<HashSet<int>>(swarmSize);
+      for (var i = 0; i < swarmSize; i++) {
+        var informs = new HashSet<int>() { i };
+        for (var j = 0; j < k; j++) {
+          informs.Add(random.Next(swarmSize));
+        }
+        particlesInform.Add(informs);
+      }
+
+      var neighbors = new ItemArray<IntArray>(swarmSize);
+      for (int i = 0; i < swarmSize; i++) {
+        // calculate the informants for each particle
+        var informants = particlesInform.Select((val, idx) => val.Contains(i) ? idx : -1).Where(x => x >= 0).ToArray();
+        neighbors[i] = new IntArray(informants);
+      }
+      NeighborsParameter.ActualValue = neighbors;
+      return base.Apply();
+    }
+  }
+}
Index: /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/TopologyInitializer.cs
===================================================================
--- /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/TopologyInitializer.cs	(revision 15276)
+++ /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/TopologyInitializer.cs	(revision 15277)
@@ -40,18 +40,6 @@
       get { return (IScopeTreeLookupParameter<IntArray>)Parameters["Neighbors"]; }
     }
-
     public ILookupParameter<IntValue> SwarmSizeParameter {
       get { return (ILookupParameter<IntValue>)Parameters["SwarmSize"]; }
-    }
-
-    #endregion
-
-    #region Parameter Values
-    protected ItemArray<IntArray> Neighbors {
-      get { return NeighborsParameter.ActualValue; }
-      set { NeighborsParameter.ActualValue = value; }
-    }
-    protected int SwarmSize {
-      get { return SwarmSizeParameter.ActualValue.Value; }
     }
     #endregion
Index: /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/VonNeumannTopologyInitializer.cs
===================================================================
--- /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/VonNeumannTopologyInitializer.cs	(revision 15276)
+++ /stable/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/VonNeumannTopologyInitializer.cs	(revision 15277)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.Algorithms.ParticleSwarmOptimization {
-  [Item("Von Neumann Topology Initializer", "Every particle is connected with the two following and the two previous particles wrapping around at the beginning and the end of the population.")]
+  [Item("Von Neumann Topology Initializer", "Every particle is informed by the two following and the two previous particles wrapping around at the beginning and the end of the swarm (in addition each particle also informs itself).")]
   [StorableClass]
   public sealed class VonNeumannTopologyInitializer : TopologyInitializer {
@@ -44,14 +44,17 @@
 
     public override IOperation Apply() {
-      ItemArray<IntArray> neighbors = new ItemArray<IntArray>(SwarmSize);
-      for (int i = 0; i < SwarmSize; i++) {
+      var swarmSize = SwarmSizeParameter.ActualValue.Value;
+
+      ItemArray<IntArray> neighbors = new ItemArray<IntArray>(swarmSize);
+      for (int i = 0; i < swarmSize; i++) {
         neighbors[i] = new IntArray(new[] {
-          (SwarmSize + i-2) % SwarmSize,
-          (SwarmSize + i-1) % SwarmSize,
-          (i+1) % SwarmSize,
-          (i+2) % SwarmSize
+          (swarmSize + i-2) % swarmSize,
+          (swarmSize + i-1) % swarmSize,
+          i,
+          (i+1) % swarmSize,
+          (i+2) % swarmSize
         });
       }
-      Neighbors = neighbors;
+      NeighborsParameter.ActualValue = neighbors;
       return base.Apply();
     }
Index: /stable/HeuristicLab.Encodings.RealVectorEncoding/3.3/HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj
===================================================================
--- /stable/HeuristicLab.Encodings.RealVectorEncoding/3.3/HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj	(revision 15276)
+++ /stable/HeuristicLab.Encodings.RealVectorEncoding/3.3/HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj	(revision 15277)
@@ -116,5 +116,14 @@
     <Compile Include="Creators\NormalDistributedRealVectorCreator.cs" />
     <Compile Include="Interfaces\IRealVectorMultiNeighborhoodShakingOperator.cs" />
+    <Compile Include="ParticleOperators\RealVectorNeighborhoodParticleUpdater.cs" />
     <Compile Include="ParticleOperators\RealVectorParticleCreator.cs" />
+    <Compile Include="ParticleOperators\RealVectorParticleUpdater.cs" />
+    <Compile Include="ParticleOperators\RealVectorSwarmUpdater.cs" />
+    <Compile Include="ParticleOperators\RealVectorTotallyConnectedParticleUpdater.cs" />
+    <Compile Include="ParticleOperators\SPSO2007VelocityInitializer.cs" />
+    <Compile Include="ParticleOperators\SPSOVelocityInitializer.cs" />
+    <Compile Include="ParticleOperators\SPSO2011ParticleUpdater.cs" />
+    <Compile Include="ParticleOperators\SPSO2007ParticleUpdater.cs" />
+    <Compile Include="ParticleOperators\SPSOParticleCreator.cs" />
     <Compile Include="Crossovers\BlendAlphaBetaCrossover.cs" />
     <Compile Include="Interfaces\IRealVectorManipulator.cs" />
@@ -128,8 +137,7 @@
     <Compile Include="Interfaces\IRealVectorSwarmUpdater.cs" />
     <Compile Include="Manipulators\SelfAdaptiveNormalAllPositionsManipulator.cs" />
-    <Compile Include="ParticleOperators\RealVectorNeighborhoodParticleUpdater.cs" />
-    <Compile Include="ParticleOperators\RealVectorParticleUpdater.cs" />
-    <Compile Include="ParticleOperators\RealVectorSwarmUpdater.cs" />
-    <Compile Include="ParticleOperators\RealVectorTotallyConnectedParticleUpdater.cs" />
+    <Compile Include="ParticleOperators\SPSOParticleUpdater.cs" />
+    <Compile Include="ParticleOperators\SPSO2011VelocityInitializer.cs" />
+    <Compile Include="ParticleOperators\SPSOSwarmUpdater.cs" />
     <Compile Include="Plugin.cs" />
     <Compile Include="RealVectorCreator.cs" />
